// MouseHookDLL.cpp

#include "StdAfx.h"
#include "Util.h"
#include "MouseHookDLL.h"

//---------------------------------------------------
// Global Variables
//---------------------------------------------------

#pragma data_seg("MY_HOOK_DATA")
	HHOOK g_mouseHook = NULL;
#pragma data_seg()

static HINSTANCE         g_hInst       = NULL;
static MouseHookHandler* g_hookHandler = NULL;

//---------------------------------------------------
// Main
//---------------------------------------------------

BOOL APIENTRY DllMain( HINSTANCE han, DWORD why, void* )
{
	switch( why )
	{
	case DLL_PROCESS_ATTACH:
		g_hInst = han;
		break;
	case DLL_PROCESS_DETACH:
		MouseHookEnd();
		break;
	}
    return TRUE;
}

LRESULT CALLBACK LowLevelMouseProc( int code, WPARAM wp, LPARAM lp )
{
	if( code==HC_ACTION && g_hookHandler )
		g_hookHandler->on_event( wp,  reinterpret_cast<MSLLHOOKSTRUCT*>(lp) );
	return ::CallNextHookEx( g_mouseHook, code, wp, lp );
}

DLL_API void MouseHookBegin( MouseHookHandler* hh )
{
	if( g_mouseHook == NULL )
	{
		g_hookHandler = hh;
		g_mouseHook   = ::SetWindowsHookEx( WH_MOUSE_LL, &LowLevelMouseProc, g_hInst, 0 );
	}
}

DLL_API void MouseHookEnd()
{
	if( g_mouseHook )
	{
		::UnhookWindowsHookEx( g_mouseHook );
		g_mouseHook   = NULL;
		g_hookHandler = NULL;
	}
}
